// Learn TypeScript:
//  - https://docs.cocos.com/creator/2.4/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/2.4/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/2.4/manual/en/scripting/life-cycle-callbacks.html

const { ccclass, property } = cc._decorator;

@ccclass
export default class Fanwei extends cc.Component {


    @property(cc.Boolean)
    mouseJoint = false

    size = cc.size(0, 0);

    onLoad() {

        let physicsManager = cc.director.getPhysicsManager();
        //开启物理系统
        physicsManager.enabled = true;
        // Debug
        // physicsManager.debugDrawFlags = 
        //     // 0;
        //     // cc.PhysicsManager.DrawBits.e_aabbBit |
        //     cc.PhysicsManager.DrawBits.e_jointBit |
        //     cc.PhysicsManager.DrawBits.e_shapeBit
        //     ;

        // 测试
        let width = this.size.width || this.node.width;
        let height = this.size.height || this.node.height;

        let node = new cc.Node();
        node.name = 'niubi'
        let body = node.addComponent(cc.RigidBody);
        body.type = cc.RigidBodyType.Static;

        if (this.mouseJoint) {
            // add mouse joint
            let joint = node.addComponent(cc.MouseJoint);
            joint.mouseRegion = this.node;
        }

        this._addBound(node, 0, height / 2, width, 30);
        this._addBound(node, 0, -height / 2, width, 30);
        this._addBound(node, -width / 2, 0, 30, height);
        this._addBound(node, width / 2, 0, 30, height);

        node.parent = this.node;
    }

    start() {

    }

    _addBound(node, x, y, width, height) {
        let collider = node.addComponent(cc.PhysicsBoxCollider);
        collider.offset.x = x;
        collider.offset.y = y;
        collider.size.width = width;
        collider.size.height = height;
    }
}
