
const { ccclass, property } = cc._decorator;

/** 水压试验 */
@ccclass
export default class WaterTest extends cc.Component {

    @property(cc.Prefab)
    waterPer: cc.Prefab = null;
    // @property(cc.Node)
    // fatherNode: cc.Node = null;

    timeCallback: Function = null;
    isInsWater: boolean = false;
    onLoad() {
        // cc.director.getPhysicsManager().enabled = true; //开启物理引擎
        //TODO： 对象池
    }

    protected onEnable(): void {
        if (this.timeCallback) {
            cc.log('清楚上一个演示函数')
            this.unschedule(this.timeCallback);
        }
        this.timeCallback = () => this.schedule(() => {
            cc.log('激活花洒碰撞器');
            this.node.getChildByName('collider').active = true;

        }, 0.35, 0);
        this.timeCallback();


    }

    protected onDisable(): void {
        this.node.getChildByName('collider').active = false;
        // cc.audioEngine.stop(sid);
    }

    start() {
        // this.initWaterPool();
        this.isInsWater = true;
    }

    /** 生成水滴 */
    insWater() {
        //cc.log('对象池内数量-',PoolManager.getInstance().getPoolSizeToMap(Pool_Name.CAT_BATH_WATER_POOL));
        //PoolManager.getInstance().getNodeByMap(Pool_Name.CAT_BATH_WATER_POOL);//
        let tW = cc.instantiate(this.waterPer);
        tW.setParent(this.node);
        tW.active = true;
        // tW.setPosition(this.node.getPosition().add(cc.v2(40 * Math.cos(Math.random()*10), -1 * Math.sin(Math.random()*10))))
        let randomX = Math.random() * this.node.width * 0.4;
        let randomAbs = Math.random();
        if (randomAbs < 0.5) {
            randomX = -randomX;
        }
        tW.setPosition(randomX, -10)

        // 添加力
        // cc.log(this.node.angle)
        let maxY = 0;
        if (this.node.angle == 0) {
            maxY = -600;
        } else {
            maxY = -400;
        }
        const gravity = cc.v2(this.node.angle * 8, maxY); // 重力加速度
        // cc.log(this.node.angle)
        let ov = gravity.mul(tW.getComponent(cc.RigidBody).getMass());
        // cc.log(ov)
        // tW.getComponent(cc.RigidBody).applyForceToCenter(gravity.mul(tW.getComponent(cc.RigidBody).getMass()), true);
        tW.getComponent(cc.RigidBody).applyLinearImpulse(gravity, cc.v2(0, 0), true);
        // tW.getComponent(cc.RigidBody).applyAngularImpulse( 1000,true)

        tW.getComponent(cc.RigidBody).angularVelocity = this.node.angle * 0.5;


        //tW.getComponent(cc.RigidBody).linearVelocity = cc.v2(this.node.angle * Math.cos(Math.random()*180), -this.node.angle * Math.sin(Math.random()*180));

    }

    update(dt) {
        if (this.isInsWater) {
            this.insWater();
            // cc.log(this.node.childrenCount)//182
        }
    }

}
